import { MyObjectArrayRefTwoDimensions } from '../model/my-object-array-ref-two-dimensions.model';
import { StandardHttpException } from 'generator-lib-commons-angular6';
import { RequestConfig, SchemesValues, Metadata, ImplicitHeadersOutput } from 'generator-lib-commons-angular6';
import { Observable } from 'rxjs';
import { HttpClient, HttpHeaders } from '@angular/common/http';
/**
 * ------------------------------------------------
 * @author API Rest Generator
 * ------------------------------------------------
 */
export declare class ArraystestService {
    private baseURI;
    private http;
    /** Constant - API Version - Key */
    static API_VERSION_KEY: string;
    /** Constant - API Version - Value */
    static API_VERSION_VALUE: string;
    /** Constant - Nova Release - Key */
    static NOVA_RELEASE_KEY: string;
    /** Attribute - Nova Release */
    novaRelease: string;
    constructor(baseURI: string, http: HttpClient);
    getBaseURI(scheme: SchemesValues): string;
    responseOneDimension(requestConfig: RequestConfig, metadata: Metadata): Observable<boolean[]>;
    /**
     * Validate the input scheme with the expected for this
     *
     * @param requestConfig with the request configuration
     */
    responseOneDimensionValidateScheme(requestConfig: RequestConfig): void;
    /**
     * The following method get the full URL
     */
    responseOneDimensionFullUrl(scheme: SchemesValues): string;
    /**
     * The following method assign every path parameter with the value
     */
    responseOneDimensionPathAssignment(urlWithScheme: string): string;
    /**
     * The following method assign every query parameter with the value
     */
    responseOneDimensionQueryAssignment(): string;
    /**
     * The following method assign every header parameter with the value
     *
     * @throws Error with an occurred exception
     */
    responseOneDimensionHeaderAssignment(implicitHeadersOutput: ImplicitHeadersOutput): HttpHeaders;
    /**
     * @param headers 			with the HTTP headers
     * @param outputHeadersMap	with the output headers map
     * @return the HTTP headers
     * @throws Error with an occurred exception
     */
    responseOneDimensionHeaderAssignmentImplicitHeadersOutput(headers: HttpHeaders, outputHeadersMap: Map<string, string[]>): HttpHeaders;
    /**
     * @param key with the key
     * @return true if the input key is duplicated
     */
    responseOneDimensionIsDuplicatedHeaderWithSpecification(key: string): boolean;
    bodySimpleType(requestConfig: RequestConfig, metadata: Metadata, bodyParameter: boolean): Observable<MyObjectArrayRefTwoDimensions[]>;
    /**
     * Validate the input scheme with the expected for this
     *
     * @param requestConfig with the request configuration
     */
    bodySimpleTypeValidateScheme(requestConfig: RequestConfig): void;
    /**
     * The following method get the full URL
     */
    bodySimpleTypeFullUrl(scheme: SchemesValues): string;
    /**
     * The following method assign every path parameter with the value
     */
    bodySimpleTypePathAssignment(urlWithScheme: string): string;
    /**
     * The following method assign every query parameter with the value
     */
    bodySimpleTypeQueryAssignment(): string;
    /**
     * The following method assign every header parameter with the value
     *
     * @throws Error with an occurred exception
     */
    bodySimpleTypeHeaderAssignment(implicitHeadersOutput: ImplicitHeadersOutput): HttpHeaders;
    /**
     * @param headers 			with the HTTP headers
     * @param outputHeadersMap	with the output headers map
     * @return the HTTP headers
     * @throws Error with an occurred exception
     */
    bodySimpleTypeHeaderAssignmentImplicitHeadersOutput(headers: HttpHeaders, outputHeadersMap: Map<string, string[]>): HttpHeaders;
    /**
     * @param key with the key
     * @return true if the input key is duplicated
     */
    bodySimpleTypeIsDuplicatedHeaderWithSpecification(key: string): boolean;
    bodyArray(requestConfig: RequestConfig, metadata: Metadata, bodyParameter: boolean[]): Observable<MyObjectArrayRefTwoDimensions[]>;
    /**
     * Validate the input scheme with the expected for this
     *
     * @param requestConfig with the request configuration
     */
    bodyArrayValidateScheme(requestConfig: RequestConfig): void;
    /**
     * The following method get the full URL
     */
    bodyArrayFullUrl(scheme: SchemesValues): string;
    /**
     * The following method assign every path parameter with the value
     */
    bodyArrayPathAssignment(urlWithScheme: string): string;
    /**
     * The following method assign every query parameter with the value
     */
    bodyArrayQueryAssignment(): string;
    /**
     * The following method assign every header parameter with the value
     *
     * @throws Error with an occurred exception
     */
    bodyArrayHeaderAssignment(implicitHeadersOutput: ImplicitHeadersOutput): HttpHeaders;
    /**
     * @param headers 			with the HTTP headers
     * @param outputHeadersMap	with the output headers map
     * @return the HTTP headers
     * @throws Error with an occurred exception
     */
    bodyArrayHeaderAssignmentImplicitHeadersOutput(headers: HttpHeaders, outputHeadersMap: Map<string, string[]>): HttpHeaders;
    /**
     * @param key with the key
     * @return true if the input key is duplicated
     */
    bodyArrayIsDuplicatedHeaderWithSpecification(key: string): boolean;
    queryArrayInputTypes(requestConfig: RequestConfig, metadata: Metadata, longArrayQuery: number[], booleanQuery: boolean, integerArrayQuery: number[], doubleArrayQuery: number[]): Observable<MyObjectArrayRefTwoDimensions[]>;
    /**
     * Validate the input scheme with the expected for this
     *
     * @param requestConfig with the request configuration
     */
    queryArrayInputTypesValidateScheme(requestConfig: RequestConfig): void;
    /**
     * The following method get the full URL
     */
    queryArrayInputTypesFullUrl(scheme: SchemesValues, longArrayQuery: number[], booleanQuery: boolean, integerArrayQuery: number[], doubleArrayQuery: number[]): string;
    /**
     * The following method assign every path parameter with the value
     */
    queryArrayInputTypesPathAssignment(urlWithScheme: string): string;
    /**
     * The following method assign every query parameter with the value
     */
    queryArrayInputTypesQueryAssignment(longArrayQuery: number[], booleanQuery: boolean, integerArrayQuery: number[], doubleArrayQuery: number[]): string;
    /**
     * The following method assign every header parameter with the value
     *
     * @throws Error with an occurred exception
     */
    queryArrayInputTypesHeaderAssignment(implicitHeadersOutput: ImplicitHeadersOutput): HttpHeaders;
    /**
     * @param headers 			with the HTTP headers
     * @param outputHeadersMap	with the output headers map
     * @return the HTTP headers
     * @throws Error with an occurred exception
     */
    queryArrayInputTypesHeaderAssignmentImplicitHeadersOutput(headers: HttpHeaders, outputHeadersMap: Map<string, string[]>): HttpHeaders;
    /**
     * @param key with the key
     * @return true if the input key is duplicated
     */
    queryArrayInputTypesIsDuplicatedHeaderWithSpecification(key: string): boolean;
    responseTwoDimensions(requestConfig: RequestConfig, metadata: Metadata): Observable<number[][]>;
    /**
     * Validate the input scheme with the expected for this
     *
     * @param requestConfig with the request configuration
     */
    responseTwoDimensionsValidateScheme(requestConfig: RequestConfig): void;
    /**
     * The following method get the full URL
     */
    responseTwoDimensionsFullUrl(scheme: SchemesValues): string;
    /**
     * The following method assign every path parameter with the value
     */
    responseTwoDimensionsPathAssignment(urlWithScheme: string): string;
    /**
     * The following method assign every query parameter with the value
     */
    responseTwoDimensionsQueryAssignment(): string;
    /**
     * The following method assign every header parameter with the value
     *
     * @throws Error with an occurred exception
     */
    responseTwoDimensionsHeaderAssignment(implicitHeadersOutput: ImplicitHeadersOutput): HttpHeaders;
    /**
     * @param headers 			with the HTTP headers
     * @param outputHeadersMap	with the output headers map
     * @return the HTTP headers
     * @throws Error with an occurred exception
     */
    responseTwoDimensionsHeaderAssignmentImplicitHeadersOutput(headers: HttpHeaders, outputHeadersMap: Map<string, string[]>): HttpHeaders;
    /**
     * @param key with the key
     * @return true if the input key is duplicated
     */
    responseTwoDimensionsIsDuplicatedHeaderWithSpecification(key: string): boolean;
    /**
     * @param statusCode with the status code
     * @param error with the instance of the error
     * @return a new instance of standard HTTP exception
     */
    generateStandardHttpExceptionFromErrorInstance(statusCode: any, error: any): StandardHttpException;
    /**
     * @param statusCode  with the status code
     * @param errorString with the error message
     * @param message 	  with the exception message
     * @param exception   with the stack trace error
     * @param path        with the path error
     * @param timestamp   with the timestamp
     * @return a new instance of standard HTTP exception
     */
    generateStandardHttpException(statusCode: number, errorString: string, message: string, exception: string, path: string, timestamp: number): StandardHttpException;
    /**
     * @param novaRelease with the NOVA release
     */
    setNovaRelease(novaRelease: string): void;
}
